#ifndef __cobj
#define __cobj

#include <string>
#include <list>
#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>
using namespace std;


class Sp_Obj;
class Sp_Adm;
class Sp_Camera;

#include "sp_time.h" 
#include "sp_matrice.h"
#include "face.h"
#include "sp_trans.h"


#define SP_NORMAL_3DPRIORITY 0
#define SP_FIRST_3DPRIORITY 1
#define SP_LAST_3DPRIORITY 2


/* ###################################################### */
/* ################## Sp_Obj ############################ */
/* ###################################################### */

class Sp_Obj
{
 public:
  
  /* ---------- The members functions  ----------- */
  // default constructor Don t use it !!!
  Sp_Obj();
  // the real constructor & his destructor
  Sp_Obj(char *name,Sp_Adm *adm3d,Sp_Obj *your_father,int priority);
  virtual ~Sp_Obj();

  // Add a son
  void Add_Son(Sp_Obj *);
  void Rem_Son(Sp_Obj *);
  // Add an Entity
  void Add_Entity(Sp_EntityBase *);
  void Rem_Entity(Sp_EntityBase *);

    virtual void Work();
  
   void ComputeObjtoCam();
   void Render();
   
  /* ---------- the members data ----------- */
 public:

  // the name of the object
  string Name;
  // The father de l objet
  Sp_Obj *father;
  // The manager of object
  Sp_Adm *adm_obj;
  
  // the sons
  list<Sp_Obj *> list_Sons;
//  list<Sp_Obj *> fils_connectes;

  // his entities
  list<Sp_EntityBase *> list_entities;
  
  // The coordinates 
  Sp_LTrans *trans;
  // The coordinates compared to the active camera
  Sp_Mat4 *coord_camera;
};


/* ###################################################### */
/* ################## Sp_Camera ######################### */
/* ###################################################### */
class Sp_Camera: public Sp_Obj
{
 public:
  Sp_Camera(char *name,Sp_Adm *adm3d,Sp_Obj *your_father);
  ~Sp_Camera();
};




/* ###################################################### */
/* ################## Sp_Obj3d ########################## */
/* ###################################################### */
class Sp_Obj3d: public Sp_Obj
{
 public:
  Sp_Obj3d(char *name,Sp_Adm *adm3d,Sp_Obj *your_father,int priority);
};




/* ###################################################### */
/* ################## Sp_Adm ########################### */
/* ###################################################### */
class Sp_Adm : public Sp_Obj, public Sp_Adm_Time
{
  public:


        // The constructor
    Sp_Adm(char *name);
    ~Sp_Adm();
    
    
        // Add and remove a camera
        // Don't use it
        // This functions are called when we constructs a camera
  void Add_Camera(Sp_Camera *camera);
  void Rem_Camera(Sp_Camera *camera);
  
      // to manage textures
  int Add_Texture(char *,int w,int h);
  int Load_texture(char *);
      // Draw the scene
  void DrawScene();

  protected:
      // Compute the reference beetween the camera and the gest3d
  Sp_Mat4 ComputeObjtoGest3d(Sp_Obj *);
 
  public:
  
      // ------- The members datas ---------

      // textures
  int texture_indice;
      // cameras
  list<Sp_Camera *> liste_cameras;
  Sp_Camera *camera_active;

      // two special lists
      // It is used to draw object at the beginning or at the ending
      // of rendering.
  list<Sp_Obj *> draw_first;
  list<Sp_Obj *> draw_last;
};

#endif
