#include "planets.h"

#define STACKS 10
#define SLICES 10
#define COEF   10

Sp_Obj_Planets *mercure,*venus,*earth,*mars,*jupiter,*saturne,*uranus,*neptune;

void Sp_Load_Planetes(Sp_Adm *gest3d,Sp_Obj *ton_pere)
{
    Sp_Trans *tr;
        // on cree une planete MERCURE
    mercure=new Sp_Obj_Planets(0.1,"mercury.png",gest3d,ton_pere,SP_FIRST_3DPRIORITY);
    tr=new Sp_Rot(gest3d,0,0,10.0/360);
    mercure->trans->Add_Trans(tr);
    tr=new Sp_Trans(gest3d);
    tr->Trans(-1.867591*COEF,0.469926*COEF,3.371086*COEF);
    mercure->trans->Add_Trans(tr);

        // on cree une planete VENUS
    venus=new Sp_Obj_Planets(0.25,"venus.png",gest3d,ton_pere,SP_FIRST_3DPRIORITY);
    tr=new Sp_Rot(gest3d,0,10.0/360,0);
    venus->trans->Add_Trans(tr);
    tr=new Sp_Trans(gest3d);
    tr->Trans(7.114879*COEF,0.199492*COEF,-1.292640*COEF);
    venus->trans->Add_Trans(tr);
    
        // on cree une planete EARTH
    earth=new Sp_Obj_Planets(0.26,"earth.png",gest3d,ton_pere,SP_FIRST_3DPRIORITY);
        // Rotation
    tr=new Sp_Rot(gest3d,10.0/360,0,0);
    earth->trans->Add_Trans(tr);
        // Translation
    tr=new Sp_Trans(gest3d);
    tr->Trans(4.579938*COEF,-0.000004*COEF,8.887195*COEF);
    earth->trans->Add_Trans(tr);

        // on cree une planete MARS
    mars=new Sp_Obj_Planets(0.14,"mars.png",gest3d,ton_pere,SP_FIRST_3DPRIORITY);
    tr=new Sp_Rot(gest3d,0,10.0/360,0);
    mars->trans->Add_Trans(tr);
    tr=new Sp_Trans(gest3d);
    tr->Trans(-12.469102*COEF,-0.488428*COEF,-8.722921*COEF);
    mars->trans->Add_Trans(tr);

        // on cree une planete JUPITER
    jupiter=new Sp_Obj_Planets(0.96,"jupiter.png",gest3d,ton_pere,SP_FIRST_3DPRIORITY);
    tr=new Sp_Rot(gest3d,0,10.0/360,0);
    jupiter->trans->Add_Trans(tr);
    tr=new Sp_Trans(gest3d);
    tr->Trans(3.869*COEF,-0.022*COEF,-51.843*COEF);
    jupiter->trans->Add_Trans(tr);
 
        // on cree une planete SATURNE
    saturne=new Sp_Obj_Planets(0.80,"saturn.png",gest3d,ton_pere,SP_FIRST_3DPRIORITY);
    tr=new Sp_Rot(gest3d,10.0/360,0,0);
    saturne->trans->Add_Trans(tr);
    tr=new Sp_Trans(gest3d);
    tr->Trans(-59.942*COEF,-3.537*COEF,74.268*COEF);
    saturne->trans->Add_Trans(tr);
    
        // on cree une planete URANUS
    uranus=new Sp_Obj_Planets(0.34,"uranus.png",gest3d,ton_pere,SP_FIRST_3DPRIORITY);
    tr=new Sp_Rot(gest3d,0,10.0/360,0);
    uranus->trans->Add_Trans(tr);
    tr=new Sp_Trans(gest3d);
    tr->Trans(-40.61*COEF,-2.58*COEF,-187.566*COEF);
    uranus->trans->Add_Trans(tr);

        // on cree une planete NEPTUNE
    neptune=new Sp_Obj_Planets(0.33,"neptune.png",gest3d,ton_pere,SP_FIRST_3DPRIORITY);
    tr=new Sp_Rot(gest3d,0,0,10.0/360);
    neptune->trans->Add_Trans(tr);
    tr=new Sp_Trans(gest3d);
    tr->Trans(188.032*COEF,7.040*COEF,234.41*COEF);
    neptune->trans->Add_Trans(tr);

}

void Sp_Delete_Planetes()
{
  delete mercure; delete venus;
  delete earth; delete mars;
  delete jupiter; delete saturne;
  delete uranus; delete neptune;
}

Sp_Obj_Planets::Sp_Obj_Planets(float radius,char *texname,Sp_Adm *gest3d,Sp_Obj *ton_pere,int priority):Sp_Obj3d(texname,gest3d,ton_pere,priority)
{
  // On cree une Sp_Entity
  Sp_Entity *entity=new Sp_Entity(this);
  
  // on a une phere
  Sp_GEntitySphere *current;
  current=new Sp_GEntitySphere(entity);
  current->radius=radius*COEF;
  current->slices=SLICES;
  current->stacks=STACKS;
  current->num_tex=gest3d->Load_texture(texname);
  entity->Add_GEntity(current);
  
  Add_Entity(entity);
}


void Sp_Obj_Planets::Draw()
{
  typedef list<Sp_EntityBase *>::iterator iter;
  typedef list<Sp_GEntity *>::iterator iter2;
  
  for(iter i=list_entities.begin();i!=list_entities.end();i++)
    {
      (*i)->Draw();
    }
}

void Sp_Obj_Planets::Work()
{
    glDisable(GL_DEPTH_TEST);
    Draw();
    glEnable(GL_DEPTH_TEST);
}
