#include "sp_newgame.h"
#include "stk/stk.h"
#include "fontgl.h"


extern int Sp_width;
extern int Sp_height;

extern Stk_AdmCtrl *admctrl;
extern int player1;

Sp_NewGame::Sp_NewGame(Stk_Prog *p)
        :Stk_Prog(p)
{
    glEnable(GL_TEXTURE_2D);
    gest3d=new Sp_Adm("Gestionnaire 3d");
    etoiles=new Sp_Obj_stars("stars.dat",gest3d,gest3d,SP_FIRST_3DPRIORITY);
    Sp_Load_Planetes(gest3d,gest3d);
        //objf=new Sp_Camera("la camera du circuit",gest3d,circuit);
    objf2=new Sp_Camera("la camera du gest",gest3d,gest3d);
    objf3=new Sp_Car("la voiture",gest3d,gest3d,admctrl->GiveControl(player1));
    circuitnew=new Sp_Obj_gl("sracer2006.gl",gest3d,gest3d,SP_NORMAL_3DPRIORITY);
    circuitphy=new Sp_Load_CircuitC("sracer2006.gl");
        // we attaches car & circuit
    objf3->PlayOnCircuit(circuitphy);
    
    
    Sp_Point dep(5,0,0.0);
    Sp_Vecteur dir(0,0,1);
    objf3->Init(circuitphy,dep,dir);
    quit=1;
    
    start=glutGet((GLenum)GLUT_ELAPSED_TIME);

    font=new Stk_FontTXF("default.txf");
    font->SetSize(20);
}



void Sp_NewGame::MessageReceived(Stk_Message *msg)
{
    int *valeur;
        // we have interest only in keyboard clavier
    if(msg->what!=KEY_EVENT)
        return;
        // we have interest in keypressed message
    msg->FindInt("pressed",valeur);
     if(*valeur==0)
        return;
    msg->FindInt("keys",valeur);
    switch(*valeur){
    case K_ENTER:
      quit=0;
      break;
    case K_QUIT:
      quit=0;
      break;
    }
}





int Sp_NewGame::Loop()
{
        // On efface le color buffer
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    gest3d->camera_active=objf3;
    gest3d->DrawScene();

    Stk_Window *window;
    window=new Stk_Window(640,480);

        // time print
    char text[100];
    current=glutGet((GLenum)GLUT_ELAPSED_TIME);
    sprintf(text," %d,%d",(int)(current-start)/1000,(int)(current-start)%1000);

    Stk_Text *t1;
    t1=new Stk_Text(font,text,STK_LEFT,0,440,window->width,window->height);
    window->Add_Widget(t1);

        // best print
    long bestlap=circuitphy->BestLap(objf3->id_journey);
    if(bestlap<0){
        sprintf(text," best ---,--");
    } else {
        sprintf(text,"best %d,%d",(int)(bestlap)/1000,(int)(bestlap)%1000);
    }

    Stk_Text *t2;
    t2=new Stk_Text(font,text,STK_LEFT,0,40,window->width,window->height);
    window->Add_Widget(t2);

    window->Draw();
    
    glutSwapBuffers();

    delete t1; delete t2;
    delete window;
    return quit;
}


Sp_NewGame::~Sp_NewGame()
{
    glDisable(GL_TEXTURE_2D);
    Sp_Delete_Planetes();
    delete gest3d;
    delete font;
}


